#include <iostream>
#include <pthread.h>
#include <semaphore.h>
#include <unistd.h>
#include <string.h>

using namespace std;

// This program presents a solution to the following problem.
// A dispatcher thread wants to spawn up to MAX_WORKERS worker 
// threads.
//

////////////////////////////////////////////////////////////////////
// GLOBAL VARIABLES AND CONSTANTS
////////////////////////////////////////////////////////////////////

// Number of bugs that can live in the pond
const int MAX_WORKERS=100;

// Current number of worker threads
int workerCount = MAX_WORKERS;


////////////////////////////////////////////////////////////////////
// Function Prototypes
////////////////////////////////////////////////////////////////////

void* worker(void *parameter);
// Precondition:  consumer pthread and semaphores initialized
// Postcondition: never returns

////////////////////////////////////////////////////////////////////
// Dispatcher Thread
////////////////////////////////////////////////////////////////////
int main(void)
{
  // Dispatch requests to worker threads
  for (int i=0; i<10000; i++)
  {
    // busy wait if too many workers
    while (workerCount==0);
    workerCount--;

    // create a new worker
    pthread_t *tidp = new pthread_t();
    int *parameter = new int;
    *parameter = i;
    pthread_create(tidp, NULL,worker, parameter);
    pthread_detach(*tidp); // need this to spawn more than 254 threads
  }
  
  // Wait for the last of the workers to complete
  sleep(5);
  cout << "main thread: count is: " << workerCount << endl;

  return 1;
}

////////////////////////////////////////////////////////////////////
// Woker Thread
////////////////////////////////////////////////////////////////////
void* worker(void *parameter)
{
  //
  // Do work here
  //
  cout << "Worker " << * (int *) parameter << endl;
  sleep(1);

  // Die and free up room for another worker
  workerCount++;

  pthread_exit(NULL);
}
